"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AdditionalVariantsQuestions(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "validationAssayType",
        "variantActionability",
        "variantTested",
        "variantUsability",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import reports as reports_6_0_1

        return {
            "variantCoordinates": reports_6_0_1.VariantCoordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import reports as reports_6_0_1

        return {
            "typeOfAdditionalFinding": reports_6_0_1.TypeOfAdditionalFinding,
            "variantActionability": reports_6_0_1.CancerActionability,
            "variantTested": reports_6_0_1.CancerTestedAdditional,
            "variantUsability": reports_6_0_1.CancerUsabilitySomatic,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import reports as reports_6_0_1

        return {
            "org.gel.models.report.avro.TypeOfAdditionalFinding": reports_6_0_1.TypeOfAdditionalFinding,
            "org.gel.models.report.avro.CancerActionability": reports_6_0_1.CancerActionability,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_0_1.VariantCoordinates,
            "org.gel.models.report.avro.CancerTestedAdditional": reports_6_0_1.CancerTestedAdditional,
            "org.gel.models.report.avro.CancerUsabilitySomatic": reports_6_0_1.CancerUsabilitySomatic,
            "org.gel.models.report.avro.AdditionalVariantsQuestions": reports_6_0_1.AdditionalVariantsQuestions,
        }

    __slots__ = [
        "validationAssayType",
        "variantActionability",
        "variantTested",
        "variantUsability",
        "findingDescription",
        "otherVariantActionability",
        "typeOfAdditionalFinding",
        "variantCoordinates",
    ]

    def __init__(
        self,
        validationAssayType,
        variantActionability,
        variantTested,
        variantUsability,
        findingDescription=None,
        otherVariantActionability=None,
        typeOfAdditionalFinding=None,
        variantCoordinates=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_0_1.AdditionalVariantsQuestions model.

        :param validationAssayType:
            Please enter validation assay type e.g Pyrosequencing, NGS panel,
            COBAS, Sanger sequencing. If not applicable enter NA;
        :type validationAssayType: str
        :param variantActionability:
            Type of potential actionability:
        :type variantActionability: list[CancerActionability]
        :param variantTested:
            Has this variant been tested by another method (either prior to or
            following receipt of this WGA)?
        :type variantTested: CancerTestedAdditional
        :param variantUsability:
            How has/will this potentially actionable variant been/be used?
        :type variantUsability: CancerUsabilitySomatic
        :param findingDescription:
        :type findingDescription: None | str
        :param otherVariantActionability:
        :type otherVariantActionability: None | str
        :param typeOfAdditionalFinding:
        :type typeOfAdditionalFinding: None | TypeOfAdditionalFinding
        :param variantCoordinates:
            Chr: Pos Ref > Alt
        :type variantCoordinates: None | VariantCoordinates
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.0.1"
